///////////////////////////////////////////////////////////////////////////////
// Filename: networkclass.h
///////////////////////////////////////////////////////////////////////////////
#ifndef _NETWORKCLASS_H_
#define _NETWORKCLASS_H_


/////////////
// GLOBALS //
/////////////
const bool NETWORK_ENABLED = true;
static char SERVER_ADDRESS[] = "192.168.1.102";
const unsigned short SERVER_PORT = 7531;


/////////////
// LINKING //
/////////////
#pragma comment(lib, "ws2_32.lib")
#pragma comment(lib, "winmm.lib")


//////////////
// INCLUDES //
//////////////
#include <winsock2.h>
#include <mmsystem.h>


///////////////////////
// MY CLASS INCLUDES //
///////////////////////
#include "networkmessages.h"


///////////////////////////////////////////////////////////////////////////////
// Class name: NetworkClass
///////////////////////////////////////////////////////////////////////////////
class NetworkClass
{
public:
	NetworkClass();
	NetworkClass(const NetworkClass&);
	~NetworkClass();

	bool Initialize();
	void Shutdown();
	void Frame();

	int GetLantency();
	bool ConnectToServer(char*, unsigned short);

	void SetThreadActive();
	void SetThreadInactive();
	bool Online();
	SOCKET GetClientSocket();
	void ReadNetworkMessage(char*);

private:
	bool InitializeWinSock();
	void ShutdownWinsock();
	void ProcessLatency();
	void SendPing();
	void HandlePingMessage();
	void SendDisconnectMessage();

private:
	SOCKET m_clientSocket;
	int m_addressLength;
	struct sockaddr_in m_serverAddress;
	short m_idNumber;
	bool m_online;
	bool m_threadActive;
	int m_latency;
	unsigned long m_pingTime;
};


/////////////////////////
// FUNCTION PROTOTYPES //
/////////////////////////
void NetworkReadFunction(void*);


#endif