////////////////////////////////////////////////////////////////////////////////
// Filename: userinterfaceclass.h
////////////////////////////////////////////////////////////////////////////////
#ifndef _USERINTERFACECLASS_H_
#define _USERINTERFACECLASS_H_


///////////////////////
// MY CLASS INCLUDES //
///////////////////////
#include "fontclass.h"


////////////////////////////////////////////////////////////////////////////////
// Class name: UserInterfaceClass
////////////////////////////////////////////////////////////////////////////////
class UserInterfaceClass
{
private:
	struct VertexType
	{
		D3DXVECTOR3 position;
	    D3DXVECTOR2 texture;
	};

	struct SentenceType
	{
		int maxLength;
		ID3D10Buffer* vertexBuffer;
		ID3D10Buffer* indexBuffer;
		int vertexCount, indexCount;
		float red, green, blue;
	};

public:
	UserInterfaceClass();
	UserInterfaceClass(const UserInterfaceClass&);
	~UserInterfaceClass();

	bool Initialize(ID3D10Device*, HWND, int, int, D3DXMATRIX);
	void Shutdown();
	void Render(ID3D10Device*);

	void SetMatrices(D3DXMATRIX, D3DXMATRIX);

	bool SetFps(int);
	bool SetCpu(int);
	bool SetLatency(int);

private:
	bool InitializeSentence(SentenceType*, int, ID3D10Device*);
	void ShutdownSentence(SentenceType*);
	bool UpdateSentence(SentenceType*, char*, int, int, float, float, float);
	void RenderSentence(ID3D10Device*, SentenceType*);
	void RenderBuffers(ID3D10Device*, SentenceType*);

private:
	int m_screenWidth, m_screenHeight;
	FontClass* m_Font;
	SentenceType* m_sentence1;
	SentenceType* m_sentence2;
	SentenceType* m_sentence3;
};

#endif