////////////////////////////////////////////////////////////////////////////////
// Filename: main.cpp
////////////////////////////////////////////////////////////////////////////////


///////////////////////
// MY CLASS INCLUDES //
///////////////////////
#include "networkclass.h"
#include "systemclass.h"


int main()
{
  SystemClass* System;
  NetworkClass* Network;
  bool result;


  // Create the system object.
  System = new SystemClass;
  if(!System)
  {
    return 0;
  }

  // Initialize the system object.
  result = System->Initialize();
  if(!result)
  {
    return 0;
  }

  // Create the network object.
  Network = new NetworkClass;
  if(!Network)
  {
    return 0;
  }

  // Initialize the network object.
  result = Network->Initialize();
  if(!result)
  {
    return 0;
  }

  while(Network->Online())
  {
    System->Frame();
  }

  // Release the network object.
  if(Network)
  {
    Network->Shutdown();
    delete Network;
    Network = 0;
  }

  // Release the system object.
  if(System)
  {
    System->Shutdown();
    delete System;
    System = 0;
  }

  return 0;
}
